///////////////////////////////
#include <acknex.h>
#include <default.c>
#include <mtlFX.c>
var engine_handle;
var distance_covered;
var score_count =0;



FONT*		fnt_pan = "Computerfont#32b";
PANEL* score_score_count 	= {digits=748,50,"Score : %00.0f",fnt_pan,1,score_count; layer = 25; flags = SHOW;green=255; blue=255; red=255; }

///////////////////////////////
STRING* work30_wmb = "work30.wmb"; 
STRING* bullet_mdl = "laserbeam.mdl"; // always define ent_created bullet models as strings!
SOUND* laser_snd = "laser.wav";
SOUND* sengine_snd = "startengine.wav";
SOUND* engine_wav = "engine.wav";
////////////////////////////////////////////////////////////////////////////////////////

function fire_bullets(); // creates the bullets
function move_bullets(); // moves the bullets
function remove_bullets(); // removes the bullets after they've hit something

BMAP* ig_map = "ingame.pcx";///<<the name of our picture we want to use 

PANEL* ig_pan = ///<<< the panel name of our picture
{
	bmap = ig_map; // calling our picture.
	pos_x = 0; ///<<< the position on screen x axis
	pos_y = 0;///<<< the position on screen y axis
	layer = 15;/////<<< the layer say an other picture has layer 11 then that one will be placed above this one.	
	flags = SHOW | OVERLAY;
}

BMAP* gr_map = "greybar.pcx";///<<the name of our picture we want to use 

PANEL* grey_pan = ///<<< the panel name of our picture
{
	bmap = gr_map; // calling our picture.
	pos_x = 20; ///<<< the position on screen x axis
	pos_y = 30;///<<< the position on screen y axis
	layer = 1;/////<<< the layer say an other picture has layer 11 then that one will be placed above this one.	
	flags = SHOW | OVERLAY;
}

var ammo=232; 

BMAP* test_map = "ammobar.pcx";


PANEL* back_pan =
{

	hbar = 20, 30, 232,test_map, 1, ammo;
	layer = 5;
	flags =  SHOW | OVERLAY; 
}

function lower_ammo()
{
	while(key_p==1)
	{
		ammo -= 1.5;		wait(1);
	}		
}

function restore_ammo()
{
	while(key_o==1)
	{wait(1);
	}	
	ammo=232;		
}

function double_ammo()
{
	while(key_l==1)
	{wait(1);
	}	
	ammo=232;		
}



//PANEL* am_pan = ///<<< the panel name of our picture
//{
	//	bmap = am_map; // calling our picture.
	//	pos_x =20; ///<<< the position on screen x axis
	//	pos_y = 30;///<<< the position on screen y axis
	//	layer = 4;/////<<< the layer say an other picture has layer 11 then that one will be placed above this one.	
	//	flags = SHOW | OVERLAY;
//}


ENTITY* sprite;


function explosion()
{
	my.ambient = 100;
	my.flags |= BRIGHT;

	{
		my.frame = 1;
		while (my.frame < 4)
		{
			my.frame += 0.7 * time_step;
			wait (1);
		}

		
	}
	wait(-0.5);
	ent_remove(me);
}


VIEW* top_view =
{                
	// sets the camera layer value, allowing it to be placed on top of other views that have a lower layer value
	layer = 500;
	// sets the position of the view on the x axis of the screen
	pos_x = 738;
	// sets the position of the view on the y axis of the screen        
	pos_y = 210;
	// sets the size of the view on the x axis of the screen        
	size_x = 282;
	// sets the size of the view on the y axis of the screen                
	size_y = 334;
	// sets the camera.arc value (zoom factor) of the view
	arc = 0;
	// set the ambient value of the view (bigger values will make the view brighter than the default camera view)
	ambient = 100;
	// displays the view
	 ambient = 10;
genius = player;
	flags = SHOW ;
}

function attached_startup() // attaches the view to the player, placing it 200 quants above it
{
	// your player code must include this line of code: "player = my;" (without using the quotes)
	while (!player) {wait (1);} // wait until the player model is loaded in the level
	top_view.tilt = -90; // make the new view look downwards
	while (1)
	{
		vec_set(top_view.x, player.x);
		top_view.z += 1900; // place the view 200 quants above the player
		//top_view.pan = gold.pan; // rotate the view together with the player
		wait (1);
	}
}

function main()
{
	video_aspect = 1.333; // enforce 4:3 mode
	video_mode = 8;
	video_screen = 1;
	level_load("spaceparanoids.WMB");
	on_p = lower_ammo;
	on_o = restore_ammo;
	on_l = double_ammo;
	media_loop("engine.wav", NULL, 30); // << start the song and sets the volume on 30. It will loop.
}

void _dlight_follow(){
   while (!player) wait (1);
   set (my, PASSABLE | INVISIBLE | LIGHT);   
   my.red        = 128;
   my.blue       = 128;
   my.green      = 128;
   my.lightrange = 150;
   while (player){
      vec_set (my.x, player.x);
      wait (1);
   }
}





void _spriteaction(){
	while (!player) wait (1);
   my.tilt = -90;
   set (my, PASSABLE);
   while (player){
      VECTOR _p; // ,_a
      vec_for_vertex (_p, you, 114); //place any vertex number here
    
   wait(1);
   }
}


action players_code()
{ 

	player = my; // I'm the player

	//set(my,INVISIBLE); // no need to see player's model in 1st person mode
	while (1)
	{

		// move the player using the "W", "S", "A" and "D" keys; "10" = movement speed, "6" = strafing speed
		c_move (my, vector(10 * (key_w - key_s) * time_step, 6 * (key_a - key_d) * time_step, 0), nullvector, GLIDE);
		if (mouse_left) // if the player presses the left mouse button
		{
			fire_bullets(); // call this function
		}
		
				vec_set (camera.x, player.x); // use player's x and y for the camera as well
		camera.x -= 0;
		camera.y -=0;
		camera.z += 25; // place the camera 30 quants above the player on the z axis (approximate eye level)
		camera.pan -= 5 * mouse_force.x * time_step; // rotate the camera around by moving the mouse
		camera.tilt += 3 * mouse_force.y * time_step; // on its x and y axis
		player.pan = camera.pan; // the camera and the player have the same pan angle
	
	
		
		wait (1);
	
}
}



function fire_bullets()
{
	proc_kill(1); // don't allow more than 1 instance of this function to run
	while (mouse_left) {wait (1);} // wait until the player releases the mouse button
	snd_play (laser_snd, 50, 0);
	ent_create("laserbeam.mdl", my.x, move_bullets); // create the bullet at camera's position and attach it the "move_bullets" function
}

action move_bullets()
{
	ammo -= 23;
	VECTOR bullet_speed; // this var will store the speed of the bullet
	my.emask |= ENABLE_BLOCK | ENABLE_ENTITY | ENABLE_IMPACT;
	my.event = remove_bullets; // when it collides with something, its event function (remove_bullets) will run
	my.pan = camera.pan; // the bullet has the same pan
	my.tilt = camera.tilt; // and tilt with the camera
	bullet_speed.x = 60 * time_step; // adjust the speed of the bullet here; it will move in the direction given by the camera
	bullet_speed.y = 0; // the bullet doesn't move sideways
	bullet_speed.z = 1; // or up / down on the z axis
	while(1) // this loop will run for as long as the bullet exists (it isn't "null")
	{
		c_move(my, bullet_speed, nullvector, IGNORE_YOU); // move the bullet ignoring its creator (the player)
		wait (1);
	}
}

function remove_bullets() // this function runs when the bullet collides with something
{
	wait(1); // wait a frame to be sure (don't trigger engine warnings)
	ent_create("explode1+4.pcx", vector(my.x,my.y,my.z), explosion);
	
	ent_remove(my); // and then remove the bullet
}

function got_shot(); // function prototype


action shootable_entity() // attach this action to your helpless enemies
{
	set(my,POLYGON);
	my.emask |= ENABLE_IMPACT | ENABLE_SHOOT;
	my.event = got_shot; // run this event function when it is hit
}

function got_shot()
{
	if (you == player) {return;} // don't die if the player runs into you, triggering an enable_impact event
	var anim_percentage = 0;
	my.event = NULL; // the enemy is dead, so it should stop reacting to other bullets from now on
	while (anim_percentage < 100) // this loop will run until the "death" animation percentage reaches 100%
	{
		ent_animate(my, "death", anim_percentage, NULL); // play the "death" animation only once
		anim_percentage += 3 * time_step; // "3" controls the animation speed
		wait (1);
	}
	set(my,PASSABLE); // allow the player to pass through the corpse now
	ent_remove(me);
}
